;Assembler-Untersttzung fr 32-Bit-Speicherverwaltung
	IDEAL
	model	small,pascal	;ohne WINDOWS, wrde Eintrittscode bei
				;FAR-Prozeduren generieren
	P386
	warn	pro		;CS:-Schreibzugriffe sperren

Bool	equ	Word
Boolean	equ	Byte
Long	equ	DWord

extrn GlobalAlloc:far
extrn GlobalReAlloc:far
extrn GlobalFree:far
;extrn GlobalLock:far
;extrn GlobalUnlock:far
extrn PostMessage:far
extrn Dos3Call:far

MaxBuffer	equ	2047	;maximal 32000
MaxTable	equ	4000000	;bis 16MB (Windows 3.1) (in Bytes) !!
ExpandIncr	equ	4000h	;in 16-KB-Schritten allozieren
WM_DongleAccess	equ	040Ah	;WM_User+10

extrn BufSel:Word
extrn Wnd:Word
extrn PlayMode:Bool		;Wiedergabe-Betriebsart

extrn TableHandle:Word
;extrn TablePtr:DWord		;Langer dynamischer Puffer
;TableOfs equ word LOW TablePtr
TableSeg equ TableHandle
extrn TableIdx:DWord, TableEnd:DWord, TableSize:DWord
	;3 Zeiger in den 32-Bit-adressierten Speicher

extrn AccessOutCount:Long	;Zhler fr Ereignisse
extrn AccessInCount:Long
extrn AccessFails:Long
extrn AccessTimeCount:Long
extrn OutNotify:Long		;Zhler fr den Konsistenz-Checker
extrn InNotify:Long
extrn TimeNotify:Long
extrn DoubleOuts:Boolean
extrn Posted:Boolean		;Keine berflssigen PostMessage()s

extrn AllocError:near		;Laufzeitfehler ausgeben

SEGMENT TableSegment word public use32	;??
ENDS

CODESEG
proc InitDkMem
public InitDkMem
	xor	eax,eax
	mov	[TableIdx],eax
	mov	[TableEnd],eax
	mov	al,10h			;Minimale Speichermenge
	mov	[TableSize],eax
	push	0			;Flags =0 (GMEM_Fixed)
	push	eax			;Anfangsgre >0 (sonst Fehler!)
	call	GlobalAlloc
	mov	[TableHandle],ax
	jmp	AllocErr
endp

proc AddLen	;EAX=Lngen-Zunahme (<ExpandIncr !!)
	add	eax,[TableEnd]
ExpandDkMem:
;PE: EAX=Neue Mindest-Gre in Bytes
	cmp	[TableSize],eax	;Momentane Gre ausreichend?
	jnc	@@e		;ja!
	add	eax,ExpandIncr-1	;nein, ReAlloc fllig!
	and	eax,-ExpandIncr		;aber nur in Seiten-Happen
	mov	[TableSize],eax		;Neue Gre in Bytes festhalten
ReAlloc:
	push	es fs		;W95 zerstrt FS und GS!
	 push	[TableHandle]
	 push	[TableSize]		;Neue Ausdehnung
	 push	0			;Flags =0
	 call	GlobalReAlloc
	 mov	[TableHandle],ax	;Neues Handle
	pop	fs es
AllocErr:
	or	ax,ax
	jnz	@@e
AllocErr2:
	call	AllocError
@@e:	ret
endp

proc NewDkMem
arg NewSize:Long
public NewDkMem
	mov	eax,[NewSize]
	call	ExpandDkMem
	ret
endp

proc ClearDkMem
public ClearDkMem
	xor	eax,eax
	mov	[TableIdx],eax
	mov	[TableEnd],eax
	mov	al,10h
	mov	[TableSize],eax		;Minimalgre
	call	ReAlloc
	ret
endp

proc DoneDkMem
public DoneDkMem
	push	[TableHandle]
	call	GlobalFree
	or	ax,ax
	jnz	AllocErr2
	ret
endp

proc AddDkLine
public AddDkLine
	mov	fs,[BufSel]
	movzx	eax,[word fs:0]		;Lngen-WORD
	add	eax,2
	push	eax
	 add	eax,eax			;Anzahl Bytes
	 call	AddLen
	pop	ecx
	xor	esi,esi
	mov	es,[TableSeg]
	mov	edi,[TableEnd]
	cld
	rep movs [word es:edi],[word fs:esi]
	mov	[TableEnd],edi
	ret
endp

proc AddInOut
	movzx	eax,[word fs:0]		;Lngen-WORD
	add	[AccessOutCount],eax
	inc	[AccessInCount]
	ret
endp AddInOut

proc IORecord
	cmp	ah,2Ch		;Code: Uhrzeit
	je	@@time
	push	ax		;AX retten; Dongle-Byte nicht verflschen
	 call	AddDkLine
	 call	AddInOut
	 cmp	ax,MaxBuffer
	 jnz	@@1
	 inc	[AccessFails]
@@1:	 call	PostMsg
	pop	ax
	ret
@@time:
	call	Dos3Call	;Uhrzeit holen!
	push	cx dx		;als LongInt auf den Stack
	 mov	eax,6		;fest: 6 Bytes zum Aufzeichnen
	 call	AddLen
	 mov	es,[TableSeg]
	 mov	edi,[TableEnd]
	 cld
	 mov	ax,802Ch	;Kennung: DOS-Uhrzeit
	 stos	[word es:edi]
	pop	eax
	stos	[dword es:edi]
	mov	[TableEnd],edi
	inc	[AccessTimeCount]
	push	eax
	 call	PostMsg
	pop	edx
	mov	ax,2C00h	;Meldung an VxD: Kette nicht weiter aufrufen!
	ret
endp

proc PostMsg
	mov	ax,[Wnd]
	or	ax,ax
	jz	@@2
	cmp	[Posted],0
	jnz	@@2
	push	ax
	push	WM_DongleAccess
	push	0
	push	large 0		;0L pushen
	call	PostMessage
	mov	[Posted],1
@@2:	ret
endp

proc Compare1
;PE: ES:EAX=Adresse im 32-Bit-Speicher
;    FS=Selektor Puffer, gefllt mit Vergleichsdaten
;    CLD!!
;PA: EAX=Adresse hinter dem verglichenen String
;    Z=1: Vergleich OK, dann es:[edi-2]=IN-Byte
;VR: EAX,ESI,EDI
	mov	edi,eax
	movzx	eax,[word es:edi]	;Lngen-Word
	or	ax,ax		;Sonder-Code (negativ)?
	js	@@1		;Raus und nicht vergleichen!
	inc	ax
	mov	ecx,eax
	inc	ax
	lea	eax,[edi+eax*2]	;Neue Adresse
	xor	esi,esi		;Puffer-Offset
	repe cmps [word fs:esi],[word es:edi]
	jnz	@@e
	inc	esi
	inc	edi
	cmps	[byte fs:esi],[byte es:edi]
@@e:	ret
@@1:	lea	eax,[edi+6]	;6 Bytes bergehen
	or	eax,eax		;sollte Z sicher lschen
	ret
endp

proc Compare2	;Suche nach Uhrzeit-Angabe
;PE: ES:EAX=Adresse im 32-Bit-Speicher
;    CLD!!
;PA: EAX=Adresse hinter dem verglichenen String
;    Z=1: Vergleich OK, dann es:[edi+2]=Uhrzeit-DWORD
;VR: EAX,EDI
	mov	edi,eax
	movzx	eax,[word es:edi]	;Lngen-Word
	or	ax,ax		;Sonder-Code (negativ)?
	js	@@1		;weiter testen!
	lea	eax,[edi+eax*2+4]	;Neue Adresse
	or	eax,eax		;Z lschen
	ret

@@1:	cmp	ax,802Ch	;Code: Uhrzeit? (setzt Z-Flag)
	lea	eax,[edi+6]	;6 Bytes bergehen
	ret
endp

proc IOReplay
;PE: AL=gelesenes IN-Byte
;PA: AL=IN-Byte (AL wird bei Fehltreffer durchgereicht)
	mov	dl,al		;Ursprngliches IN-Byte
	mov	es,[TableSeg]
	mov	fs,[BufSel]
	cld
	cmp	ah,2Ch		;Uhrzeit gewnscht?
	mov	eax,[TableIdx]	;Laufzeiger
	je	@@tf1		;Extrawurst braten
	jmp	@@f1
@@l1:	call	Compare1
	jz	@@found
@@f1:	cmp	eax,[TableEnd]
	jc	@@l1
	xor	eax,eax		;an den Anfang stellen!
	jmp	@@f2
@@l2:	call	Compare1
	jz	@@found
@@f2:	cmp	eax,[TableIdx]
	jc	@@l2
	mov	dh,-1		;"leeres" IN-Port
	inc	[AccessFails]
	jmp	@@notf
@@found:
	mov	[TableIdx],eax	;Neuen Zeiger speichern
	movzx	dx,[byte es:edi-2]	;das zu emulierende IN-Byte!
@@notf:	push	dx
	 call	AddInOut
	 call	PostMsg
	pop	ax		;IN-Byte
	ret

;Sofern berhaupt eine Uhrzeitangabe in der Tabelle drinsteckt,
;liefert dieser Zweig in jedem Falle etwas sinnvolles!
@@tl1:	call	Compare2
	jz	@@tf
@@tf1:	cmp	eax,[TableEnd]
	jc	@@tl1
	xor	eax,eax		;an den Anfang stellen!
	jmp	@@tf2
@@tl2:	call	Compare2
	jz	@@tf
@@tf2:	cmp	eax,[TableIdx]
	jc	@@tl2
	inc	[AccessFails]
	xor	edx,edx		;Nicht gefunden: Null Uhr liefern
	mov	al,1
	jmp	@@tf3
@@tf:
	mov	[TableIdx],eax	;Neuen Zeiger speichern
	mov	edx,[es:edi+2]
	inc	[AccessTimeCount]
	mov	al,0
@@tf3:	push	eax edx
	 call	PostMsg
	pop	edx eax
	ret
endp

proc TheCallback far
public TheCallback
ifdef debug
	int	1		;{Debug}
endif
	mov	dx,@data
	mov	ds,dx
	cmp	[PlayMode],0
	jnz	@@play
	call	IORecord	;liefert die Uhrzeit in EDX
	jmp	@@ex
@@play:	call	IOReplay
@@ex:	sti
	ret
endp

proc IsConsistent	;liefert TRUE (AL=1 und CY=0), wenn konsistent
public IsConsistent
	mov	es,[TableSeg]
	xor	esi,esi		;Anfangs-Adresse
	xor	eax,eax		;High-Teil immer Null
	mov	[OutNotify],eax
	mov	[InNotify],eax
	mov	[TimeNotify],eax
	mov	[DoubleOuts],al
	jmp	@@f		;Fugesteuerte Pseudo-Kopf-Schleife
@@la:	lods	[word es:esi]
	or	ax,ax		;Erweiterungs-Kennung?
	js	@@neg
	cmp	ax,MaxBuffer
	ja	@@e		;Fehler - Lngen-WORD zu gro!
	add	[OutNotify],eax
	inc	[InNotify]
	mov	cx,ax
	jcxz	@@nl
	mov	dx,-1		;Vorhergehender OUT-Befehl
@@li:	lods	[word es:esi]
	cmp	ah,3		;Nur OUT-Befehle (AH=0, 1 oder 2)?
	jnc	@@e		;Fehler: Kein OUT-Byte
	cmp	ax,dx
	jne	@@ne
	mov	[DoubleOuts],1
@@ne:	xchg	dx,ax		;OUT-Befehl merken
	loop	@@li
@@nl:	lods	[word es:esi]
	sub	ah,4
	cmp	ah,3
	jnc	@@e		;Fehler: Kein IN-Byte
@@f:	cmp	esi,[TableEnd]
	jc	@@la
	jz	@@ex		;mit CY=0 und AL=1
@@e:	stc
@@ex:	setnc	al
	ret
@@neg:
	cmp	ax,802Ch	;Uhrzeit-Kennung?
	jne	@@e		;nein - raus!
	inc	[TimeNotify]
	add	esi,4		;4 Uhrzeit-Bytes bergehen
	jmp	@@f
endp

	END




